import React from 'react';
import { TableCellProps } from './TableCell';
import { Paths } from './types';
export declare type ColumnProps<T> = {
    label?: React.ReactNode;
    value?: any;
    index?: number;
    source?: (T extends object ? Paths<T> : string) | number;
    sortable?: boolean;
    record?: T;
    className?: string;
} & Pick<TableCellProps, 'rowSpan' | 'colSpan' | 'sticky'>;
export declare type ColumnPropsWithChildren<T> = ColumnProps<T> & {
    children?: React.ReactNode | ((args: ColumnProps<T>) => React.ReactNode);
};
export declare function Column<T>(props: ColumnPropsWithChildren<T>): any;
