"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HeaderCell = void 0;

var _clsx2 = _interopRequireDefault(require("clsx"));

var _react = _interopRequireDefault(require("react"));

var _ColumnPropsContext = require("./ColumnPropsContext");

var _TableCell = require("./TableCell");

var _hooks = require("./hooks");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var HeaderCell = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var _clsx;

  var className = props.className,
      setSortBy = props.setSortBy,
      sortable = props.sortable,
      sortBy = props.sortBy,
      sortType = props.sortType,
      multiSort = props.multiSort,
      sortIconAsc = props.sortIconAsc,
      sortIconDesc = props.sortIconDesc,
      icon = props.icon,
      label = props.label,
      source = props.source,
      restProps = _objectWithoutProperties(props, ["className", "setSortBy", "sortable", "sortBy", "sortType", "multiSort", "sortIconAsc", "sortIconDesc", "icon", "label", "source"]);

  var _useSortByColumn = (0, _hooks.useSortByColumn)({
    source: source,
    setSortBy: setSortBy,
    sortable: sortable,
    sortBy: sortBy,
    sortType: sortType,
    multiSort: multiSort
  }),
      handleSorting = _useSortByColumn.handleSorting,
      desc = _useSortByColumn.desc;

  var sortIcon = desc === true ? sortIconDesc : desc === false ? sortIconAsc : icon;
  return /*#__PURE__*/_react["default"].createElement(_ColumnPropsContext.ColumnPropsContext.Provider, {
    value: _objectSpread({
      handleSorting: handleSorting,
      desc: desc,
      source: source,
      sortable: sortable
    }, restProps)
  }, /*#__PURE__*/_react["default"].createElement(_TableCell.TableCell, _extends({
    onClick: handleSorting,
    className: (0, _clsx2["default"])(className, 'cb-HeaderCell', (_clsx = {}, _defineProperty(_clsx, "cb-HeaderCell_sort_".concat(desc ? 'desc' : 'asc'), typeof desc === 'boolean'), _defineProperty(_clsx, 'cb-HeaderCell_sortable', sortable), _clsx)),
    isHeader: true,
    ref: ref
  }, restProps), /*#__PURE__*/_react["default"].createElement("div", {
    className: "cb-HeaderCellContent"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "cb-HeaderCellContent__label"
  }, label), !!sortIcon && /*#__PURE__*/_react["default"].createElement("div", {
    className: "cb-HeaderCellContent__icon"
  }, sortIcon))));
});

exports.HeaderCell = HeaderCell;