import React from 'react';
import { OnRowClick } from './types';
export declare type TableProps = React.ComponentProps<'table'> & {
    /** Make the header to be sticky */
    stickyHeader?: boolean;
    /** Make rows striped */
    striped?: boolean;
    rowHover?: boolean;
    useDiv?: boolean;
    onRowClick?: OnRowClick;
    row?: React.ReactElement;
    cell?: React.ReactElement;
    headerCell?: React.ReactElement;
    header?: React.ReactElement | null | false;
    body?: React.ReactElement;
    data?: Array<any>;
};
export declare const Table: {
    (props: TableProps): JSX.Element;
    defaultProps: {
        header: JSX.Element;
        body: JSX.Element;
        row: JSX.Element;
        headerCell: JSX.Element;
        cell: JSX.Element;
        data: never[];
    };
};
