"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Table = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _react = _interopRequireDefault(require("react"));

var _HeaderCell = require("./HeaderCell");

var _TableBody = require("./TableBody");

var _TableCell = require("./TableCell");

var _TableHeader = require("./TableHeader");

var _TableRow = require("./TableRow");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Table = function Table(props) {
  var data = props.data,
      children = props.children,
      className = props.className,
      stickyHeader = props.stickyHeader,
      striped = props.striped,
      rowHover = props.rowHover,
      onClick = props.onClick,
      onRowClick = props.onRowClick,
      row = props.row,
      headerCell = props.headerCell,
      header = props.header,
      body = props.body,
      useDiv = props.useDiv,
      cell = props.cell;
  var Component = useDiv ? 'div' : 'table';
  return /*#__PURE__*/_react["default"].createElement(Component, {
    className: (0, _clsx["default"])('cb-Table', className, {
      'cb-Table_sticky': stickyHeader,
      'cb-Table_noData': !(data !== null && data !== void 0 && data.length)
    }),
    onClick: onClick
  }, !!header && /*#__PURE__*/_react["default"].cloneElement(header, {
    headerCell: headerCell,
    useDiv: useDiv
  }, children), !!body && /*#__PURE__*/_react["default"].cloneElement(body, {
    striped: striped,
    data: data,
    rowHover: rowHover,
    onRowClick: onRowClick,
    row: row,
    cell: cell,
    useDiv: useDiv
  }, children));
};

exports.Table = Table;
Table.defaultProps = {
  header: /*#__PURE__*/_react["default"].createElement(_TableHeader.TableHeader, null),
  body: /*#__PURE__*/_react["default"].createElement(_TableBody.TableBody, null),
  row: /*#__PURE__*/_react["default"].createElement(_TableRow.TableRow, null),
  headerCell: /*#__PURE__*/_react["default"].createElement(_HeaderCell.HeaderCell, null),
  cell: /*#__PURE__*/_react["default"].createElement(_TableCell.TableCell, null),
  data: []
};