"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TableBody = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _react = _interopRequireDefault(require("react"));

var _TableCell = require("./TableCell");

var _TableRow = require("./TableRow");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var TableBody = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var row = props.row,
      data = props.data,
      _props$currentIndex = props.currentIndex,
      currentIndex = _props$currentIndex === void 0 ? 0 : _props$currentIndex,
      onRowClick = props.onRowClick,
      children = props.children,
      striped = props.striped,
      rowHover = props.rowHover,
      className = props.className,
      useDiv = props.useDiv,
      cell = props.cell,
      offset = props.offset,
      restProps = _objectWithoutProperties(props, ["row", "data", "currentIndex", "onRowClick", "children", "striped", "rowHover", "className", "useDiv", "cell", "offset"]);

  var Component = useDiv ? 'div' : 'tbody';
  return /*#__PURE__*/_react["default"].createElement(Component, _extends({
    className: (0, _clsx["default"])('cb-TableBody', className, {
      'cb-TableBody_rowHover': rowHover
    }),
    ref: ref
  }, restProps), !!offset && offset >= 0 && /*#__PURE__*/_react["default"].createElement("tr", {
    className: "cb-RowSpacer",
    style: {
      height: offset
    }
  }), !!row && data.map(function (record, recordIndex) {
    var index = recordIndex + currentIndex;
    var oddEvenClassName;

    if (striped) {
      oddEvenClassName = index % 2 > 0 ? 'cb-TableRow_odd' : 'cb-TableRow_even';
    }

    return /*#__PURE__*/_react["default"].cloneElement(row, {
      className: oddEvenClassName,
      onClick: onRowClick,
      record: record,
      index: index,
      useDiv: useDiv,
      cell: cell,
      key: index
    }, children);
  }));
});

exports.TableBody = TableBody;
TableBody.defaultProps = {
  data: [],
  currentIndex: 0,
  row: /*#__PURE__*/_react["default"].createElement(_TableRow.TableRow, null),
  cell: /*#__PURE__*/_react["default"].createElement(_TableCell.TableCell, null)
};