"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TableCell = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var TableCell = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var children = props.children,
      className = props.className,
      sticky = props.sticky,
      isHeader = props.isHeader,
      onClick = props.onClick,
      useDiv = props.useDiv,
      rowSpan = props.rowSpan,
      colSpan = props.colSpan,
      styleProp = props.style;

  var _React$useState = _react["default"].useState({}),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      style = _React$useState2[0],
      setStyle = _React$useState2[1];

  var cellRef = _react["default"].useRef(null);

  var Component = useDiv ? 'div' : isHeader ? 'th' : 'td';
  var isTableCell = Component === 'th' || Component === 'td';
  var cellProps = {};

  if (isTableCell) {
    cellProps = {
      rowSpan: rowSpan,
      colSpan: colSpan
    };
  }

  _react["default"].useImperativeHandle(ref, function () {
    return cellRef.current;
  });

  _react["default"].useEffect(function () {
    if (sticky && cellRef.current) {
      var isRightSticky = sticky === 'right';
      setStyle({
        position: 'sticky',
        left: isRightSticky ? undefined : cellRef.current.offsetLeft,
        right: isRightSticky ? 0 : undefined,
        zIndex: isHeader ? 2 : 1
      });
    }
  }, [sticky, isHeader]);

  return /*#__PURE__*/_react["default"].createElement(Component, _extends({
    className: (0, _clsx["default"])('cb-TableCell', className, {
      'cb-TableCell_sticky': sticky
    }),
    style: _objectSpread(_objectSpread({}, style), styleProp),
    onClick: onClick,
    ref: cellRef
  }, cellProps), children);
});

exports.TableCell = TableCell;