"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TableRow = void 0;

var _clsx = _interopRequireDefault(require("clsx"));

var _react = _interopRequireDefault(require("react"));

var _TableCell = require("./TableCell");

var _get = require("./utils/get");

var _mapChildren = require("./utils/mapChildren");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var TableRow = /*#__PURE__*/_react["default"].forwardRef(function TableRow(props, ref) {
  var children = props.children,
      cell = props.cell,
      className = props.className,
      record = props.record,
      index = props.index,
      onClick = props.onClick,
      useDiv = props.useDiv,
      columnProps = props.columnProps,
      restProps = _objectWithoutProperties(props, ["children", "cell", "className", "record", "index", "onClick", "useDiv", "columnProps"]);

  var handleClick = _react["default"].useMemo(function () {
    if (!onClick) return;
    return function (event) {
      onClick(event, record, index);
    };
  }, [onClick]);

  var Component = useDiv ? 'div' : 'tr';
  return /*#__PURE__*/_react["default"].createElement(Component, _extends({
    className: (0, _clsx["default"])('cb-TableRow', className),
    onClick: handleClick,
    ref: ref
  }, restProps), !!cell && (0, _mapChildren.mapChildren)(children, function (child, childIndex) {
    var source = child.props.source;
    var value = source ? (0, _get.get)(record, source) : undefined;
    return /*#__PURE__*/_react["default"].cloneElement(cell, _objectSpread({
      key: childIndex,
      useDiv: useDiv
    }, child.props), /*#__PURE__*/_react["default"].cloneElement(child, _objectSpread({
      record: record,
      index: index,
      value: value
    }, columnProps)));
  }));
});

exports.TableRow = TableRow;
TableRow.defaultProps = {
  cell: /*#__PURE__*/_react["default"].createElement(_TableCell.TableCell, null)
};