"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.VirtualTable = void 0;

var _react = _interopRequireDefault(require("react"));

var _clsx = _interopRequireDefault(require("clsx"));

var _Table = require("./Table");

var _TableBody = require("./TableBody");

var _useVirtualTable2 = require("./hooks/useVirtualTable");

var _HeaderCell = require("./HeaderCell");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var VirtualTable = function VirtualTable(props) {
  var _props$data = props.data,
      data = _props$data === void 0 ? [] : _props$data,
      className = props.className,
      restProps = _objectWithoutProperties(props, ["data", "className"]);

  var tableWrapRef = _react["default"].useRef();

  var headerCellRefs = _react["default"].useRef(new Set());

  var _useVirtualTable = (0, _useVirtualTable2.useVirtualTable)(data, {
    tableWrapRef: tableWrapRef,
    headerCellRefs: headerCellRefs
  }),
      rootProps = _useVirtualTable.rootProps,
      tableBodyProps = _useVirtualTable.tableBodyProps,
      tableProps = _useVirtualTable.tableProps,
      containerHeight = _useVirtualTable.containerHeight;

  var setHeaderCellRef = _react["default"].useCallback(function (element) {
    if (element) {
      headerCellRefs.current.add(element);
    }
  }, []);

  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    className: (0, _clsx["default"])('cb-VirtualTable', className)
  }, rootProps), /*#__PURE__*/_react["default"].createElement("div", {
    className: "cb-VirtualTable-table-wrap",
    ref: tableWrapRef
  }, /*#__PURE__*/_react["default"].createElement(_Table.Table, _extends({}, restProps, tableProps, {
    body: /*#__PURE__*/_react["default"].createElement(_TableBody.TableBody, tableBodyProps),
    headerCell: /*#__PURE__*/_react["default"].createElement(_HeaderCell.HeaderCell, {
      ref: setHeaderCellRef
    })
  }))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "cb-VirtualTable__height",
    style: {
      height: containerHeight
    }
  }));
};

exports.VirtualTable = VirtualTable;