"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useRowSelect = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useRowSelect = function useRowSelect(_ref) {
  var data = _ref.data,
      _ref$idKey = _ref.idKey,
      idKey = _ref$idKey === void 0 ? 'id' : _ref$idKey;

  var _React$useState = _react["default"].useState([]),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      selectedRowIds = _React$useState2[0],
      setSelectedRowIds = _React$useState2[1];

  var isRowSelected = _react["default"].useCallback(function (record) {
    return selectedRowIds.indexOf(record[idKey]) !== -1;
  }, [selectedRowIds, idKey]);

  var isAllRowsSelected = _react["default"].useCallback(function () {
    return selectedRowIds.length && selectedRowIds.filter(function (id) {
      return data.some(function (dataItem) {
        return dataItem[idKey] === id;
      });
    }).length === data.length;
  }, [selectedRowIds, data, idKey]);

  var toggleRowSelected = _react["default"].useCallback(function (record) {
    var id = record[idKey];
    var selectedIndex = selectedRowIds.indexOf(id);
    var newSelected = [];

    if (selectedIndex === -1) {
      newSelected = newSelected.concat(selectedRowIds, id);
    } else if (selectedIndex === 0) {
      newSelected = newSelected.concat(selectedRowIds.slice(1));
    } else if (selectedIndex === selectedRowIds.length - 1) {
      newSelected = newSelected.concat(selectedRowIds.slice(0, -1));
    } else if (selectedIndex > 0) {
      newSelected = newSelected.concat(selectedRowIds.slice(0, selectedIndex), selectedRowIds.slice(selectedIndex + 1));
    }

    setSelectedRowIds(newSelected);
  }, [selectedRowIds, idKey]);

  var toggleAllRowsSelected = _react["default"].useCallback(function () {
    if (isAllRowsSelected()) return setSelectedRowIds([]);
    setSelectedRowIds(Array.from(new Set([].concat(_toConsumableArray(selectedRowIds), _toConsumableArray(data.map(function (item) {
      return item[idKey];
    }))))));
  }, [selectedRowIds, isAllRowsSelected, idKey]);

  return {
    selectedRowIds: selectedRowIds,
    setSelectedRowIds: setSelectedRowIds,
    isRowSelected: isRowSelected,
    isAllRowsSelected: isAllRowsSelected,
    toggleRowSelected: toggleRowSelected,
    toggleAllRowsSelected: toggleAllRowsSelected
  };
};

exports.useRowSelect = useRowSelect;