"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSortBy = void 0;

var _react = _interopRequireDefault(require("react"));

var sortTypes = _interopRequireWildcard(require("../utils/sortTypes"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useSortBy = function useSortBy(_ref) {
  var data = _ref.data,
      sortBy = _ref.sortBy,
      defaultSortBy = _ref.defaultSortBy,
      onSort = _ref.onSort;

  var _React$useRef = _react["default"].useRef(sortBy !== undefined),
      isControlled = _React$useRef.current;

  var _React$useState = _react["default"].useState(defaultSortBy),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      sortByState = _React$useState2[0],
      setSortByState = _React$useState2[1];

  var value = isControlled ? sortBy : sortByState;

  var sortedData = _react["default"].useMemo(function () {
    return !!data && value ? orderBy(data, value) : data;
  }, [sortByState, data]);

  var setValueIfUncontrolled = _react["default"].useCallback(function (newValue) {
    if (!isControlled) {
      setSortByState(newValue);
    }
  }, [isControlled]);

  var handleChange = function handleChange(newValue) {
    setValueIfUncontrolled(newValue);

    if (onSort) {
      onSort(newValue);
    }
  };

  return {
    sortBy: value,
    setSortBy: handleChange,
    sortedData: sortedData
  };
};

exports.useSortBy = useSortBy;

var orderBy = function orderBy(data) {
  var dirs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  if (!dirs.length) return data;
  return _toConsumableArray(data).sort(function (rowA, rowB) {
    for (var i = 0; i < dirs.length; i += 1) {
      var sorting = dirs[i];
      var desc = sorting.desc,
          sortType = sorting.sortType,
          id = sorting.id;
      var sortFn = typeof sortType === 'function' ? sortType : sortTypes[sortType] || sortTypes.basic;
      var sortInt = sortFn(rowA, rowB, id);

      if (sortInt !== 0) {
        return desc ? -sortInt : sortInt;
      }
    }
  });
};