"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSortByColumn = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var useSortByColumn = function useSortByColumn(_ref) {
  var source = _ref.source,
      setSortBy = _ref.setSortBy,
      sortable = _ref.sortable,
      sortBy = _ref.sortBy,
      sortType = _ref.sortType,
      multiSort = _ref.multiSort;

  if (process.env.NODE_ENV !== 'production') {
    _react["default"].useEffect(function () {
      if (sortable && !source) {
        console.error('A column has the "sortable" prop without the "source" prop. Define the "source" prop to make the sorting working for this column');
      }
    }, [sortable, source]);
  }

  var sorting = _react["default"].useMemo(function () {
    return sortBy && sortBy.length ? sortBy.find(function (item) {
      return item.id === source;
    }) || {} : {};
  }, [sortBy]);

  var desc = sorting.desc,
      id = sorting.id;

  var handleSorting = _react["default"].useMemo(function () {
    if (!sortable || !setSortBy || !source) return;
    return function () {
      var nextDesc = !id ? true : !desc ? undefined : false;
      var newSortBy = typeof nextDesc === 'boolean' ? [{
        id: source,
        desc: nextDesc,
        sortType: sortType
      }] : [];
      setSortBy(multiSort && sortBy !== null && sortBy !== void 0 && sortBy.length ? [].concat(_toConsumableArray(sortBy.filter(function (item) {
        return item.id !== source;
      })), newSortBy) : newSortBy);
    };
  }, [sortable, sortBy, source, sortType, setSortBy]);

  return {
    handleSorting: handleSorting,
    desc: desc
  };
};

exports.useSortByColumn = useSortByColumn;