"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.get = void 0;

var get = function get(obj, path, defaultValue) {
  if (obj[path]) return obj[path];
  return String(path).split('.').reduce(function (acc, v) {
    try {
      acc = acc[v] === undefined ? defaultValue : acc[v];
    } catch (e) {
      return defaultValue;
    }

    return acc;
  }, obj);
};

exports.get = get;