"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mapChildren = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactIs = require("react-is");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var mapChildren = function mapChildren(children, callback) {
  var result = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

  _react["default"].Children.map(children, function (child, index) {
    if (!child || ! /*#__PURE__*/_react["default"].isValidElement(child)) return;

    if ((0, _reactIs.isFragment)(child)) {
      mapChildren(child.props.children, callback, result);
      return;
    }

    result.push(callback(child, index));
  });

  return result;
};

exports.mapChildren = mapChildren;